# Stack Reporter

Stack Reporter is a Drupal module that exposes a secure API endpoint to report your site's technology stack information.

## Features

- Secure API endpoint protected by configurable API key
- Reports Drupal, PHP, and Node.js versions
- Easy configuration through Drupal's admin interface

## Installation

1. Download and install the module using Composer:
   ```
   composer require drupal/stack_reporter
   ```

2. Enable the module via Drush:
   ```
   drush en stack_reporter
   ```
   
   Or through the Drupal admin interface at `/admin/modules`.

## Configuration

1. Navigate to `/admin/config/system/stack-reporter`
2. Enter your API key and other site information
3. Select the frameworks and libraries used in your site
4. Save the configuration

## Usage

### API Endpoint

The module exposes an API endpoint at:
```
/api/v1/stack-reporter
```

### Authentication

Access requires an API key that can be provided in either:
1. Query parameter: `?apikey=your_api_key`
2. JSON request body: `{"apikey": "your_api_key"}`

### Sample Response

```json
{
  "drupal_version": "10.1.2",
  "php_version": "8.2.7",
  "node_version": "18.16.0",
}
```

## Requirements

- Drupal 9.4 or higher
- PHP 8.0 or higher

## Troubleshooting

### API Key Authentication Issues

If you're having trouble authenticating:
- Verify the API key in the module configuration
- Check that you're using the correct parameter name (`apikey`)
- Try both request methods (query parameter and JSON body)

### Node.js Version Detection

Node.js detection requires:
- The `exec()` function to be enabled in PHP
- Node.js to be installed and accessible in the server environment

## Maintainer

[Justin Neel](https://www.drupal.org/u/xpersonas)

## License

This project is licensed under the GPL v2 or later.